Require Export String.
Open Scope string_scope.

Ltac move_to_top x :=
  match reverse goal with
  | H : _ |- _ => try move x after H
  end.

Ltac Case s := let c := fresh "case" in set (c := s); move_to_top c.


Tactic Notation "remember" constr(c) "as" ident(x) "in" "|-" :=
  let x := fresh x in
  let H := fresh "Heq" x in
  (set (x := c); assert (H : x = c) by reflexivity; clearbody x).


Axiom skip : False.
Ltac skip := assert False; [ apply skip | contradiction ].

